!-----------------------------------------------------------------------------
! NIM.R : gioca a NIM usando tre pile di monete (da una versione originale
! inglese)
!-----------------------------------------------------------------------------

PROGRAM NIM

DIM PILE%[3],PARITY%[4],BIT%[3,4]

FUNCTION GAMEOVER(X)
   GAMEOVER=(PILE%[1]+PILE%[2]+PILE%[3]=0)
END FUNCTION

FUNCTION ODD(X)
   ODD=(FRC(X/2)<>0)
END FUNCTION

FUNCTION RANDOM(X)
   RANDOM=INT(RND(1)*X)
END FUNCTION

!$I="XT.LIB"

PROCEDURE CONSTANT
  NROWS%=21
  DELAY%=1000
  MONEY%=177
END PROCEDURE

PROCEDURE DISPLAY
 CLS
 FOR P%=1 TO 3
   FIRSTCOL%=P%*10
   FOR ROW%=0 TO NROWS%-1
     IF PILE%[P%]>=NROWS%-ROW% THEN
       LOCATE(ROW%,FIRSTCOL%+3)
       PRINT(CHR$(MONEY%);CHR$(MONEY%);CHR$(MONEY%);)
     END IF
   END FOR
   LOCATE(NROWS%-1,FIRSTCOL%)
   PRINT(MID$(STR$(PILE%[P%]),2))
 END FOR
END PROCEDURE

PROCEDURE SIGNON
 CLS
 PRINT("                   ***  N I M  ***")
 PRINT PRINT
 PRINT(" I will set up three piles of coins to move, take any numbers of")
 PRINT(" coins away from any pile. The player who clears the screen wins")
 PRINT
 PRINT(" Now hit any key to start ....")
 REPEAT
   GET(A$)
 UNTIL A$<>""
END PROCEDURE

PROCEDURE HISMOVE
  HOME
  PRINT("Now enter your move : ")
  REPEAT
    PRINT
    PRINT("Pile ( 1 to 3 ) ";)
    INPUT(PNUMBER%)
    OK%=(PNUMBER%>=1 AND PNUMBER%<=3)
    IF OK% THEN
       PRINT("Number to take away";)
       INPUT(NTAKEN%)
       OK%=(NTAKEN%>=1 AND NTAKEN%<=PILE%[PNUMBER%])
    END IF
    IF NOT OK% THEN PRINT("What ??") END IF
  UNTIL OK%
  PILE%[PNUMBER%]=PILE%[PNUMBER%]-NTAKEN%
END PROCEDURE

PROCEDURE MYMOVE
!
!  BIT%[I%,J%] contiene la rappresentazione binaria alla rovescia di PILE%[I%]
!
!  PARITY%[I%] contiene -1 se PILE%[I%] ha parit dispari sugli uni
!
  FOR I%=1 TO 3
    X%=PILE%[I%]
    FOR J%=4 TO 1 STEP -1
      BIT%[I%,J%]=ODD(X%)
      X%=INT(X%/2)
    END FOR
 END FOR
 FOR I%=1 TO 4
    PARITY%[I%]=BIT%[1,I%]<>(BIT%[2,I%]<>BIT%[3,I%])
 END FOR
 PNUMBER%=1 NTAKEN%=0
 IF NOT (PARITY%[1] OR PARITY%[2] OR PARITY%[3] OR PARITY%[4])
    THEN
     WHILE PILE%[PNUMBER%]=0
      PNUMBER%=PNUMBER%+1
     END WHILE
     IF PILE%[PNUMBER%]=1 THEN NTAKEN%=1
                          ELSE NTAKEN%=RANDOM(PILE%[PNUMBER%]-1)+1
     END IF
    ELSE
     FIRSTBIT%=1
     WHILE NOT PARITY%[FIRSTBIT%]
      FIRSTBIT%=FIRSTBIT%+1
     END WHILE
     WHILE NOT BIT%[PNUMBER%,FIRSTBIT%]
       PNUMBER%=PNUMBER%+1
     END WHILE
     FOR I%=FIRSTBIT% TO 4
       X%=1
       IF I%<=3 THEN
         FOR J%=3 TO I% STEP -1
           X%=X%*2
         END FOR
       END IF
       IF PARITY%[I%] THEN
          IF BIT%[PNUMBER%,I%] THEN NTAKEN%=NTAKEN%+X%
                               ELSE NTAKEN%=NTAKEN%-X%
          END IF
       END IF
     END FOR
   END IF
   PILE%[PNUMBER%]=PILE%[PNUMBER%]-NTAKEN%
END PROCEDURE

BEGIN
  CONSTANT
  SIGNON
  I%=RND(-VAL(RIGHT$(TIME$,2))) ! inizializza il generatore di casuali
  REPEAT
    FOR I%=1 TO 3
      PILE%[I%]=RANDOM(10)+6
    END FOR
    DISPLAY
    REPEAT
      HISMOVE
      IF GAMEOVER(0) THEN PRINT("Congratulation, you win !!")
                     ELSE DISPLAY
                          MYMOVE
                          FOR I%=1 TO DELAY% END FOR
                          DISPLAY
                          PRINT("My move was";NTAKEN%;"from pile";PNUMBER%)
                          IF GAMEOVER(0) THEN PRINT("*** I win !!")
                          END IF
                          PRINT PRINT
      END IF
   UNTIL GAMEOVER(0)
   PRINT("Another game ?")
   REPEAT
     GET(CH$)
   UNTIL CH$<>""
UNTIL (CH$="N" OR CH$="n")
CLS
END PROGRAM
