!-----------------------------------------------------------------------
! BREAKOUT.R : gioca a breakout su schermo a 40 colonne CGA
!-----------------------------------------------------------------------

PROGRAM BREAKOUT

!$S=47104
           ! definisce il segmento di memoria indirizzabile
           ! relativo alla memoria della Color Graphic Card.
           ! Per la Monochrome Graphic Card l'indirizzo dopo
           ! SEGMENT deve essere 45056.
           ! Per l'uso con la M.G.C. bisogna usare il modo a
           ! 80 colonne e bisogna perci cambiare tutte le
           ! PEEK & POKE.
!$K

!$I="XT.LIB"

 PROCEDURE AGGIORNA
     COLOR(0,7)
     LOCATE(1,1)
     PRINT(STRING$(80," ");)
     LOCATE(1,1)
     PRINT("SCORE";TAB(7);SCORE;TAB(15);"LIVES";)
     PRINT(TAB(21);LIVES;TAB(25);"HISCORE";TAB(34);HISCORE)
     COLOR(7,0)
 END PROCEDURE

 PROCEDURE MUOVI
   GET(A$)
   IF (A$="Z" OR A$="z") AND R<>0
      THEN
        R=R-1
        POKE(1924+2*R,32)
        POKE(1920+2*R,220)
   END IF
   IF (A$="M" OR A$="m") AND R<>38
      THEN
        R=R+1
        POKE(1918+2*R,32)
        POKE(1922+2*R,220)
   END IF
 END PROCEDURE

 PROCEDURE PRESENTAZIONE
  CLS
  COLOR(7,0)
  PRINT
  PRINT
  PRINT(TAB(12);"                              ")
  PRINT(TAB(12);"                                           ")
  PRINT(TAB(12);"                                           ")
  PRINT(TAB(12);"                                ")
  PRINT(TAB(12);"                                           ")
  PRINT(TAB(12);"                                           ")
  PRINT(TAB(12);"                                   ")
  PRINT
  PRINT
  PRINT(TAB(5);"Premi 'Z' and 'M' per muovere a destra e sinistra, 'N' per uscire dal gioco")
  PRINT
  PRINT(TAB(18);"PREMI UN TASTO PER CONTINUARE")
  REPEAT
   GET(A$)
  UNTIL A$<>""
  HISCORE=0
END PROCEDURE

BEGIN
  PRESENTAZIONE
  WIDTH("SCRN:",40)
  REPEAT
   SCORE=0 ! punteggio della partita corrente
   LIVES=3 ! numero di vite del giocatore
   AGGIORNA
   REPEAT
    PRINT(STRING$(40," ");)
    FOR J=1 TO 2
      PRINT(STRING$(40,176);)
    END FOR
    FOR J=1 TO 2
      PRINT(STRING$(40,177);)
    END FOR
    FOR J=1 TO 2
      PRINT(STRING$(40,178);)
    END FOR
    PRINT(STRING$(40," ");)
    REPEAT
      X=INT(RND(1)*9+6)
      Y=10
      R=INT(RND(1)*20+5)
      POKE(1920+2*R,220)
      POKE(1922+2*R,220)
      MUOVI
      DX=-1*(INT(RND(1)+0.5))
      DY=1
      IF DX=0
       THEN
         DX=1
      END IF
      REPEAT
        F=0
        X0=X
        Y0=Y
        X=X+DX
        Y=Y+DY
        MUOVI
        IF X=0 OR X=39
          THEN
           DX=-DX
           F=1
           IF Y>=2 AND Y<=22
             THEN
              Y=Y+DY
           END IF
        END IF
        MUOVI
        FLAG%=FALSE
        IF Y=23 AND X=R
           THEN
             SOUND(50,3)
             DY=-DY
             IF F=0 AND DX=1
               THEN
                DX=-1
                FLAG%=TRUE
             END IF
        END IF
        IF Y=23 AND X=R+1
           THEN
            SOUND(50,3)
            DY=-DY
            IF F=0 AND DX=-1
              THEN
               DX=1
               FLAG%=TRUE
            END IF
       END IF
       IF NOT FLAG%
          THEN
           DY=DY*((Y=1)-(Y<>1))
           ESCAPE%=(Y=25)
      END IF
      MUOVI
      IF NOT FLAG% AND NOT ESCAPE%
         THEN
          AGAIN%=FALSE
          TEMP=PEEK(2*X+80*Y)
          IF TEMP>=176 AND TEMP<=178
             THEN
               MUOVI
               DY=-DY
               SCORE=SCORE+10*(4-INT((Y/2)/2))
               AGGIORNA
               IF FRC(SCORE/64000)=0
                  THEN
                    POKE(1922+2*R,32)
                    POKE(1920+2*R,32)
                    LIVES=LIVES+1
                    AGGIORNA
                    AGAIN%=TRUE
               END IF
           END IF
       END IF
       IF NOT FLAG% AND NOT ESCAPE% AND NOT AGAIN%
          THEN
            MUOVI
       END IF
       IF NOT ESCAPE% AND NOT AGAIN%
          THEN
            POKE(2*X0+80*Y0,32)
            POKE(2*X+80*Y,ASC("o"))
       END IF
       UNTIL ESCAPE% OR AGAIN%
       IF NOT AGAIN% THEN
          GAME%=FALSE
          POKE(1922+2*R,32)
          POKE(1920+2*R,32)
          POKE(2*X0+80*Y0,32)
          LIVES=LIVES-1
          AGGIORNA
          IF LIVES=0 THEN
             PRINT(TAB(10);"-- GIOCO FINITO !! --")
             GAME%=TRUE
          END IF
       END IF
       UNTIL GAME%
       IF NOT AGAIN% AND SCORE>HISCORE
          THEN
             HISCORE=SCORE
             AGGIORNA
       END IF
    UNTIL NOT AGAIN%
    REPEAT
      GET(A$)
   UNTIL A$<>""
 UNTIL (A$="N" OR A$="n")
 WIDTH("SCRN:",80)
END PROGRAM
