!----------------------------------------------------------------------------
! DESKTOP.R : Simula una calcolatrice RPN con le quattro operazioni, l'ele-
! vamento a potenza e il calcolo di percentuali.
!----------------------------------------------------------------------------

PROGRAM DESKTOP

!$D
! attiva i calcoli a virgola mobile in doppia precisione

DIM STACK[50]

!$I="XT.LIB"

PROCEDURE GETEXPRESSION(->ZETA$)
  ERRORE%=FALSE
  SP%=0
  INPUT(ZETA$)
END PROCEDURE

PROCEDURE SKIPBLANK(ZETA$->H$)
  H$=""
  WHILE MID$(ZETA$,I%,1)<>BLANK$
    H$=H$+MID$(ZETA$,I%,1)
    I%=I%+1
  END WHILE
END PROCEDURE

PROCEDURE ERROR
  ERRORE%=TRUE
  PRINT("Manca un operatore o un operando")
END PROCEDURE

PROCEDURE TYPEVALUE
  IF SP%=1 THEN PRINT(STACK[SP%])
           ELSE ERROR
  END IF
END PROCEDURE

PROCEDURE STACKGESTION(H$)
  OPERATOR%=FALSE
  CASE H$ OF
    "+"-> IF SP%>1 THEN
                    SP%=SP%-1
                    STACK[SP%]=STACK[SP%]+STACK[SP%+1]
                    OPERATOR%=TRUE
          END IF
     END ->
    "-"-> IF SP%>1 THEN
                    SP%=SP%-1
                    STACK[SP%]=STACK[SP%]-STACK[SP%+1]
                    OPERATOR%=TRUE
          END IF
     END ->
    "*"-> IF SP%>1 THEN
                    SP%=SP%-1
                    STACK[SP%]=STACK[SP%]*STACK[SP%+1]
                    OPERATOR%=TRUE
          END IF
     END ->
    "/"-> IF SP%>1 THEN
                    SP%=SP%-1
                    STACK[SP%]=STACK[SP%]/STACK[SP%+1]
                    OPERATOR%=TRUE
          END IF
     END ->
    "%"-> IF SP%>1 THEN
                    SP%=SP%-1
                    STACK[SP%]=STACK[SP%]*STACK[SP%+1]/100
                    OPERATOR%=TRUE
           END IF
     END ->
     "^"->
          IF SP%>1 THEN
                    SP%=SP%-1
                    STACK[SP%]=STACK[SP%]^STACK[SP%+1]
                    OPERATOR%=TRUE
          END IF
     END ->
    END CASE
    IF NOT OPERATOR% THEN
        IF VAL(H$)=0 AND H$<>"0" THEN ERROR
                                 ELSE SP%=SP%+1
                                      STACK[SP%]=VAL(H$)
        END IF
     END IF
END PROCEDURE

PROCEDURE COMPUTEEXPRESSION
  GETEXPRESSION(->X$)
  IF X$<>"\"
     THEN X$=X$+BLANK$
          FOR I%=1 TO LEN(X$)
              SKIPBLANK(X$->H$)
              IF H$<>"" THEN STACKGESTION(H$)
              END IF
          END FOR
          IF NOT ERRORE%
             THEN TYPEVALUE
          END IF
     ELSE FUORI%=TRUE
  END IF
END PROCEDURE

EXCEPTION
  ERRORE%=TRUE
  CASE ERR OF           ! ERR e' una variabile riservata che contiene
                        ! il codice dell'errore
     6-> PRINT("Errore di overflow") END ->
    11-> PRINT("Divisione per zero") END ->
  END CASE
END EXCEPTION

BEGIN
  BLANK$=CHR$(32)
  PRINT(CHR$(12);"Calcolatrice RPN by C.L. - 1988 ( / per uscire)")
  FUORI%=FALSE
  WHILE NOT FUORI%
    COMPUTEEXPRESSION
  END WHILE
END PROGRAM
